
; based on Numbered Health Bar

lorom
header

incsrc conf.asm

assert !MaxHealth != $00
assert !BarLength != $00
assert !MaxHealth*!BarLength < $40
assert !BarPosition >= $0EF9
assert !BarPosition+!BarLength <= $0F30

org $01C510	; disable item box
db $00,$00,$00,$00,$00,$00,$00,$00
db $00,$00,$00,$00,$00,$00,$00,$00
db $00,$00,$00,$00

org $9E2C
autoclean JML GameLoad
NOP #2

org $A5E8
JML LevelLoad
NOP #2

org $A126
autoclean JML OverworldLoad

org $F2E0
autoclean JML MidwayHeal
NOP #4

org $01C56F
autoclean JML MushFlowerDupHeal
NOP

org $01C598
autoclean JML CapeHeal

org $F614
autoclean JML Death

org $F5F8
autoclean JML Hit

; base status bar (item box removed)
org $8C81
db $FC,$38,$FC,$38,$FC,$38,$FC,$38
db $30,$28,$31,$28,$32,$28,$33,$28
db $34,$28,$FC,$38,$FC,$3C,$FC,$3C
db $FC,$3C,$FC,$3C,$FC,$38,$FC,$38
db $FC,$38,$FC,$38,$FC,$38,$FC,$38
db $FC,$38,$3D,$3C,$3E,$3C,$3F,$3C
db $FC,$38,$FC,$38,$FC,$38,$2E,$3C
db $26,$38,$FC,$38,$FC,$38,$00,$38
db $26,$38,$FC,$38,$00,$38,$FC,$38
db $FC,$38,$FC,$38,$64,$28,$26,$38
db $FC,$38,$FC,$38,$FC,$38,$FC,$38
db $FC,$38,$FC,$38,$FC,$38,$FC,$38
db $FE,$3C,$FE,$3C,$00,$3C,$FC,$38
db $FC,$38,$FC,$38,$FC,$38,$FC,$38
db $FC,$38,$FC,$38,$00,$38,$FC,$38
db $FC,$38,$FC,$38,$FC,$38

; overwrite
org !BarPosition*2+$6E97
rep !BarLength : dw $2D35

org $A2D8
autoclean JML DrawBar1
org $A5D8
autoclean JML DrawBar2
NOP #2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; levelnum.ips (disassembly) - credit goes to BMF for this
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ORG $05D8B9
		JSR LevelNumCode

ORG $05DC46
LevelNumCode:	LDA.b $0E  		; Load level number, 1st part of hijacked code
		STA.w $010B		; Store it in free RAM
		ASL A    		; 2nd part of hijacked code
		RTS


freecode

!L4 = !BarLength*4

!Health = !FreeRam
!Pos = !FreeRam+1
!Dest = !FreeRam+2

GameLoad:
	; original code
	STA $0DBE
	STZ $0DBF
	; init rams

	LDA $00
	PHA
	PHX

	STZ $00
	LDX #$00
-
	LDA $00
	STA $4204
	STZ $4205
	LDA #!MaxHealth
	STA $4206
	NOP #8
	LDA $4214
	STA !Dest,x

	LDA $00
	CLC
	ADC #!L4
	STA $00
	INX
	CPX #!MaxHealth+1
	BCC -

	PLX
	PLA
	STA $00
	JML $009E32

LevelLoad:
	; this routine is actually for some special cases(intro/titlescreen levels)
	PHA
	PHP
	REP #$20
	LDA $010B
	CMP #!TitleScreen
	BEQ +
	CMP #!Intro
	BNE ++
+
	SEP #$20

	LDA $19
	BNE +
	INC $19
+
	LDA #!MaxHealth
	STA !Health
	LDA #!BarLength*4
	STA !Pos
++
	; original code
	PLP
	PLA
	LDX $0701
	STX $0903
	JML $00A5EE

OverworldLoad:
	JSL $04DC09	; original code
	LDA $19
	BNE +
	INC $19
+
	LDA $0DB8
	BNE +
	INC $0DB8
+
	LDA $0DB9
	BNE +
	INC $0DB9
+
	LDA #!MaxHealth
	STA !Health
	LDA #!BarLength*4
	STA !Pos
	JML $00A12A

MidwayHeal:
	LDA #!MaxHealth
	STA !Health
	LDA $19		; actually redundant code
	BNE +
	INC $19
+
	JML $00F2E8

MushFlowerDupHeal:
	LDA $9E,x
	CMP #$76	; star doesn't heal
	BEQ +
	JSR ItemHeal
+
	LDA #$04
	LDY $1534,x
	JML $01C574
CapeHeal:
	JSR ItemHeal
	LDA #$02
	STA $19
	JML $01C59C
ItemHeal:
	LDA !Health
	INC
	CMP #!MaxHealth
	BCC +
	LDA #!MaxHealth
+
	STA !Health
	RTS

Death:
	LDA #$00
	STA !Health
	LDA #$09
	STA $71
	JML $00F618

Hit:
	; default
	LDA !Health
	DEC
	STA !Health
	BEQ +
	JML $00F5FC
+
	STZ $1DF9
	JML $00F606


DrawBar:
	PHB
	PHK
	PLB

	LDA $19
	BNE +
	INC $19
+
	LDA !Health
	TAX
	LDA !Dest,x
	STA $00
	LDA !Pos
	CMP $00
	BEQ +
	BCS .dec
	INC
	BRA +
.dec
	DEC
+
	STA !Pos
	REP #$20
	LDA $010B
	CMP #!TitleScreen
	SEP #$20
	BEQ +
	JSR .palette
	LDX $0681
	LDA #$04
	STA $0682,x
	LDA #$0E
	STA $0683,x
	LDA $00
	STA $0684,x
	LDA $01
	STA $0685,x
	LDA $02
	STA $0686,x
	LDA $03
	STA $0687,x
	LDA #$00
	STA $0688,x
	TXA
	CLC
	ADC #$06
	STA $0681
+
	LDA !Pos
	STA $00
	LDX #$00
.loop
	LDA $00
	CMP #$04
	BCS .full
	TAY
	LDA .tile,y
	STA !BarPosition,x
	STZ $00
	BRA .skip
.full
	LDA #$36
	STA !BarPosition,x
	LDA $00
	SEC
	SBC #$04
	STA $00
.skip
	INX
	CPX #!BarLength
	BCC .loop
.ret
	PLB
	RTS
.tile
	db $35,$32,$33,$34

.palette
	LDA !Pos
	CMP #!BarLength*2+1
	BCS .g
	CMP #!BarLength+1
	BCS .y
.r
	REP #$20
	LDA #!Palette_Red_Border
	STA $00
	LDA #!Palette_Red
	STA $02
	SEP #$20
	RTS
.y
	REP #$20
	LDA #!Palette_Yellow_Border
	STA $00
	LDA #!Palette_Yellow
	STA $02
	SEP #$20
	RTS
.g
	REP #$20
	LDA #!Palette_Green_Border
	STA $00
	LDA #!Palette_Green
	STA $02
	SEP #$20
	RTS

DrawBar1:
	JSR DrawBar
	JSL $00E2BD
	JML $00A2DC

DrawBar2:
	JSR DrawBar
	REP #$30
	PHB
	LDX #$0703
	JML $00A5DE
